Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.0.0 E15725-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tangosol.io.nio
Class ByteBufferReadBuffer.ByteBufferInput

`java.lang.Object
java.io.InputStream
com.tangosol.io.AbstractReadBuffer.AbstractBufferInput
com.tangosol.io.nio.ByteBufferReadBuffer.ByteBufferInput`

All Implemented Interfaces:
  InputStreaming, ReadBuffer.BufferInput, Closeable, DataInput

Enclosing class:
  ByteBufferReadBuffer

      public final class ByteBufferReadBuffer.ByteBufferInput

extends AbstractReadBuffer.AbstractBufferInput
implements ReadBuffer.BufferInput

This is a simple implementation of the BufferInput interface on top of a ByteBuffer.

Author:
  cp 2006.04.06

Field Summary
`protected ByteBuffer` | `m_buf` The ByteBuffer object from which data is read.

Constructor Summary
`ByteBufferReadBuffer.ByteBufferInput(ByteBuffer buf)` Default constructor.

Method Summary
`protected void` | `adjustOffsetInternal(int cb)` Adjust the internal stream offset.
`int` | `available()` Returns the number of bytes that can be read (or skipped over) from this input stream without causing a blocking I/O condition to occur. This method reflects the assumed implementation of various buffering InputStreams, which can guarantee non-blocking reads up to the extent of their buffers, but beyond that the read operations will have to read from some underlying (and potentially blocking) source.
`protected String` | `convertUTF(int of, int cb)` Convert a UTF-8 encoded section of the binary stream into a String.
`ByteBuffer` | `getByteBuffer()` Obtain the ByteBuffer that this ReadBuffer is based on.
`int` | `getOffset()` Determine the current offset of this BufferInput within the underlying ReadBuffer.
`void` | `mark(int cbReadLimit)` Marks the current read position in the InputStream in order to support the stream to be later "rewound" (using the `InputStreaming.reset()` method) to the current position. The caller passes in the maximum number of bytes that it expects to read before calling the `InputStreaming.reset()` method, thus indicating the upper bounds of the responsibility of the stream to be able to buffer what it has read in order to support this functionality.
`int` | `read()` Read the next byte of data from the InputStream. The value byte is returned as an `int` in the range `0` to `255`. If the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.
`int` | `read(byte[] abDest, int ofDest, int cbDest)` Read up to `cb` bytes from the input stream and store them into the passed array `ab` starting at offset `of`. The number of bytes actually read is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.
`byte` | `readByte()` Read a byte value. This method is the counterpart for the `DataOutput.writeByte(int)` method.
`char` | `readChar()` Read a char value. This method is the counterpart for the `DataOutput.writeChar(int)` method.
`double` | `readDouble()` Read a double value. This method is the counterpart for the `DataOutput.writeDouble(double)` method.
`float` | `readFloat()` Read a float value. This method is the counterpart for the `DataOutput.writeFloat(float)` method.
`int` | `readInt()` Read an int value. This method is the counterpart for the `DataOutput.writeInt(int)` method.
`long` | `readLong()` Read a long value. This method is the counterpart for the `DataOutput.writeLong(long)` method.
`short` | `readShort()` Read a short value. This method is the counterpart for the `DataOutput.writeShort(int)` method.
`int` | `readUnsignedShort()` Read an unsigned short value. This method is the counterpart for the `DataOutput.writeShort(int)` method when it is used with unsigned 16-bit values.
`void` | `reset()` Rewind this stream to the position at the time the `InputStreaming.mark(int)` method was last called on this InputStream. If the InputStream cannot fulfill this contract, it should throw an IOException.
`void` | `setOffsetInternal(int of)` Update the internal stream offset.
`int` | `skipBytes(int cb)` Skips over up to the specified number of bytes of data. The number of bytes actually skipped over may be fewer than the number specified to skip, and may even be zero; this can be caused by an end-of-file condition, but can also occur even when there is data remaining to be read. As a result, the caller should check the return value from this method, which indicates the actual number of bytes skipped.

Methods inherited from class com.tangosol.io.AbstractReadBuffer.AbstractBufferInput
`close, getBuffer, getCharBuf, getMarkInternal, markSupported, read, readBoolean, readBuffer, readFully, readFully, readLine, readPackedInt, readPackedLong, readSafeUTF, readUnsignedByte, readUTF, readUTF, setMarkInternal, setOffset, skip`

Methods inherited from interface com.tangosol.io.ReadBuffer.BufferInput
`close, getBuffer, markSupported, readBoolean, readBuffer, readFully, readFully, readLine, readPackedInt, readPackedLong, readSafeUTF, readUnsignedByte, readUTF, setOffset`

Methods inherited from interface com.tangosol.io.InputStreaming
`read, skip`

Field Detail

### m_buf

    protected ByteBuffer m_buf

  The ByteBuffer object from which data is read.

Constructor Detail

### ByteBufferReadBuffer.ByteBufferInput

    public ByteBufferReadBuffer.ByteBufferInput(ByteBuffer buf)

  Default constructor.

Method Detail

### getByteBuffer

    public ByteBuffer getByteBuffer()

  Obtain the ByteBuffer that this ReadBuffer is based on.
  Returns:
    the underlying ByteBuffer

### read

    public int read()
             throws IOException

  Read the next byte of data from the InputStream. The value byte is returned as an `int` in the range `0` to `255`. If the end of the stream has been reached, the value `-1` is returned.

  This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  Specified by:
    `read` in interface `InputStreaming`
  Overrides:
    `read` in class `AbstractReadBuffer.AbstractBufferInput`
  Returns:
    the next byte of data, or `-1` if the end of the stream has been reached
  Throws:
    `IOException` - if an I/O error occurs

### read

    public int read(byte[] abDest,
                    int ofDest,
                    int cbDest)
             throws IOException

  Read up to `cb` bytes from the input stream and store them into the passed array `ab` starting at offset `of`. The number of bytes actually read is returned.

  This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  Specified by:
    `read` in interface `InputStreaming`
  Overrides:
    `read` in class `AbstractReadBuffer.AbstractBufferInput`
  Parameters:
    `abDest` - the array to store the bytes which are read from the stream
    `ofDest` - the offset into the array that the read bytes will be stored
    `cbDest` - the maximum number of bytes to read
  Returns:
    the number of bytes read from the stream, or `-1` if no bytes were read from the stream because the end of the stream had been reached
  Throws:
    `IOException` - if an I/O error occurs

### mark

    public void mark(int cbReadLimit)

  Marks the current read position in the InputStream in order to support the stream to be later "rewound" (using the `InputStreaming.reset()` method) to the current position. The caller passes in the maximum number of bytes that it expects to read before calling the `InputStreaming.reset()` method, thus indicating the upper bounds of the responsibility of the stream to be able to buffer what it has read in order to support this functionality.
  Specified by:
    `mark` in interface `InputStreaming`
  Specified by:
    `mark` in interface `ReadBuffer.BufferInput`
  Overrides:
    `mark` in class `AbstractReadBuffer.AbstractBufferInput`
  Parameters:
    `cbReadLimit` - the maximum number of bytes that caller expects the InputStream to be able to read before the mark position becomes invalid

### reset

    public void reset()
               throws IOException

  Rewind this stream to the position at the time the `InputStreaming.mark(int)` method was last called on this InputStream. If the InputStream cannot fulfill this contract, it should throw an IOException.
  Specified by:
    `reset` in interface `InputStreaming`
  Overrides:
    `reset` in class `AbstractReadBuffer.AbstractBufferInput`
  Throws:
    `IOException` - if an I/O error occurs, for example if this has not been marked or if the mark has been invalidated

### available

    public int available()
                  throws IOException

  Returns the number of bytes that can be read (or skipped over) from this input stream without causing a blocking I/O condition to occur. This method reflects the assumed implementation of various buffering InputStreams, which can guarantee non-blocking reads up to the extent of their buffers, but beyond that the read operations will have to read from some underlying (and potentially blocking) source.
  Specified by:
    `available` in interface `InputStreaming`
  Specified by:
    `available` in interface `ReadBuffer.BufferInput`
  Overrides:
    `available` in class `AbstractReadBuffer.AbstractBufferInput`
  Returns:
    the number of bytes that can be read from this InputStream without blocking
  Throws:
    `IOException` - if an I/O error occurs

### skipBytes

    public int skipBytes(int cb)
                  throws IOException

  Skips over up to the specified number of bytes of data. The number of bytes actually skipped over may be fewer than the number specified to skip, and may even be zero; this can be caused by an end-of-file condition, but can also occur even when there is data remaining to be read. As a result, the caller should check the return value from this method, which indicates the actual number of bytes skipped.
  Specified by:
    `skipBytes` in interface `ReadBuffer.BufferInput`
  Specified by:
    `skipBytes` in interface `DataInput`
  Overrides:
    `skipBytes` in class `AbstractReadBuffer.AbstractBufferInput`
  Parameters:
    `cb` - the maximum number of bytes to skip over
  Returns:
    the actual number of bytes that were skipped over
  Throws:
    `IOException` - if an I/O error occurs

### readByte

    public byte readByte()
                  throws IOException

  Read a byte value.

  This method is the counterpart for the `DataOutput.writeByte(int)` method.

  Specified by:
    `readByte` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readByte` in interface `DataInput`
  Overrides:
    `readByte` in class `AbstractReadBuffer.AbstractBufferInput`
  Returns:
    a `byte` value
  Throws:
    `EOFException` - if the value could not be read because no more data remains to be read
    `IOException` - if an I/O error occurs

### readShort

    public short readShort()
                    throws IOException

  Read a short value.

  This method is the counterpart for the `DataOutput.writeShort(int)` method.

  Specified by:
    `readShort` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readShort` in interface `DataInput`
  Overrides:
    `readShort` in class `AbstractReadBuffer.AbstractBufferInput`
  Returns:
    a `short` value
  Throws:
    `EOFException` - if the value could not be read because no more data remains to be read
    `IOException` - if an I/O error occurs

### readUnsignedShort

    public int readUnsignedShort()
                          throws IOException

  Read an unsigned short value.

  This method is the counterpart for the `DataOutput.writeShort(int)` method when it is used with unsigned 16-bit values.

  Specified by:
    `readUnsignedShort` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readUnsignedShort` in interface `DataInput`
  Overrides:
    `readUnsignedShort` in class `AbstractReadBuffer.AbstractBufferInput`
  Returns:
    an `int` value in the range of 0x0000 to 0xFFFF
  Throws:
    `EOFException` - if the value could not be read because no more data remains to be read
    `IOException` - if an I/O error occurs

### readChar

    public char readChar()
                  throws IOException

  Read a char value.

  This method is the counterpart for the `DataOutput.writeChar(int)` method.

  Specified by:
    `readChar` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readChar` in interface `DataInput`
  Overrides:
    `readChar` in class `AbstractReadBuffer.AbstractBufferInput`
  Returns:
    a `char` value
  Throws:
    `EOFException` - if the value could not be read because no more data remains to be read
    `IOException` - if an I/O error occurs

### readInt

    public int readInt()
                throws IOException

  Read an int value.

  This method is the counterpart for the `DataOutput.writeInt(int)` method.

  Specified by:
    `readInt` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readInt` in interface `DataInput`
  Overrides:
    `readInt` in class `AbstractReadBuffer.AbstractBufferInput`
  Returns:
    an `int` value
  Throws:
    `EOFException` - if the value could not be read because no more data remains to be read
    `IOException` - if an I/O error occurs

### readLong

    public long readLong()
                  throws IOException

  Read a long value.

  This method is the counterpart for the `DataOutput.writeLong(long)` method.

  Specified by:
    `readLong` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readLong` in interface `DataInput`
  Overrides:
    `readLong` in class `AbstractReadBuffer.AbstractBufferInput`
  Returns:
    a `long` value
  Throws:
    `EOFException` - if the value could not be read because no more data remains to be read
    `IOException` - if an I/O error occurs

### readFloat

    public float readFloat()
                    throws IOException

  Read a float value.

  This method is the counterpart for the `DataOutput.writeFloat(float)` method.

  Specified by:
    `readFloat` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readFloat` in interface `DataInput`
  Overrides:
    `readFloat` in class `AbstractReadBuffer.AbstractBufferInput`
  Returns:
    a `float` value
  Throws:
    `EOFException` - if the value could not be read because no more data remains to be read
    `IOException` - if an I/O error occurs

### readDouble

    public double readDouble()
                      throws IOException

  Read a double value.

  This method is the counterpart for the `DataOutput.writeDouble(double)` method.

  Specified by:
    `readDouble` in interface `ReadBuffer.BufferInput`
  Specified by:
    `readDouble` in interface `DataInput`
  Overrides:
    `readDouble` in class `AbstractReadBuffer.AbstractBufferInput`
  Returns:
    a `double` value
  Throws:
    `EOFException` - if the value could not be read because no more data remains to be read
    `IOException` - if an I/O error occurs

### getOffset

    public int getOffset()

  Determine the current offset of this BufferInput within the underlying ReadBuffer.
  Specified by:
    `getOffset` in interface `ReadBuffer.BufferInput`
  Overrides:
    `getOffset` in class `AbstractReadBuffer.AbstractBufferInput`
  Returns:
    the offset of the next byte to read from the ReadBuffer

### setOffsetInternal

    public void setOffsetInternal(int of)

  Update the internal stream offset.
  Overrides:
    `setOffsetInternal` in class `AbstractReadBuffer.AbstractBufferInput`
  Parameters:
    `of` - the new offset

### adjustOffsetInternal

    protected void adjustOffsetInternal(int cb)

  Adjust the internal stream offset.
  Overrides:
    `adjustOffsetInternal` in class `AbstractReadBuffer.AbstractBufferInput`
  Parameters:
    `cb` - the number of bytes that were written

### convertUTF

    protected String convertUTF(int of,
                                int cb)
                         throws IOException

  Convert a UTF-8 encoded section of the binary stream into a String.
  Overrides:
    `convertUTF` in class `AbstractReadBuffer.AbstractBufferInput`
  Parameters:
    `of` - the offset within the stream
    `cb` - the length in bytes within the stream
  Returns:
    the String value
  Throws:
    `IOException`

Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.0.0 E15725-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.